package com.sample;

import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.rule.WorkingMemoryEntryPoint;

public class TestEventRunner implements Runnable {
    
    private WorkingMemoryEntryPoint ep;
    
    private StatefulKnowledgeSession ksession;

    public StatefulKnowledgeSession getKsession() {
        return ksession;
    }

    public void setKsession(StatefulKnowledgeSession ksession) {
        this.ksession = ksession;
    }

    public WorkingMemoryEntryPoint getEp() {
        return ep;
    }

    public void setEp(WorkingMemoryEntryPoint ep) {
        this.ep = ep;
    }

    @Override
    public void run() {
        try {
            Thread.sleep(500); // make sure ksession started
            
            //---- Write test events here
            ep.insert(new ParkingEvent("CarA", "ParkingA", ParkingEvent.ENTER));
            Thread.sleep(500);
            
            ep.insert(new ParkingEvent("CarB", "ParkingA", ParkingEvent.ENTER));
            Thread.sleep(500);
            
            ep.insert(new ParkingEvent("CarA", "ParkingA", ParkingEvent.EXIT));
            Thread.sleep(500);
            
            ep.insert(new ParkingEvent("CarA", "ParkingB", ParkingEvent.ENTER));
            //Thread.sleep(1000);
            
            //----
            
//            Thread.sleep(1000); // make sure all events processed
//            ksession.halt();
            
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

}
